#!/usr/bin/env julia

function clearPrimes(p, n)
	p[1] = false
end

function sievePrimes(p, n)
	for i = 2:n, j = i*i:i:n  # step is in the middle
		p[j] = false
	end
end

function printPrimes(p, n)
	for i = 1:n
		if p[i]
			print(i, " ")
		end
	end
	println()
end

function primes(n)
	p = trues(n)
	clearPrimes(p, n)
	sievePrimes(p, n)
	printPrimes(p, n)
end

function main(argv)
	if length(argv) > 0
		primes(parse(Int, argv[1]))
	else
		println("Usage: primes COUNT")
	end
end

main(ARGS)
