/** primes.rexx */
/* Created 2019-09-26 */
/* Copyright © 2019 by Mark Damon Hughes. All Rights Reserved. */

PARSE ARG primeCount
IF \ DATATYPE(primeCount, "W") THEN DO
	SAY "Usage: primes.rexx N"
	EXIT 1
END

CALL clearPrimes
CALL sievePrimes
CALL printPrimes
EXIT 0

clearPrimes: PROCEDURE EXPOSE primes. primeCount
	primes. = 1
	primes.0 = primeCount
	primes.1 = 0
RETURN

sievePrimes: PROCEDURE EXPOSE primes. primeCount
	DO i = 2 TO primeCount
		DO j = (i * i) TO primeCount BY i
			primes.j = 0
		END
	END
RETURN

printPrimes: PROCEDURE EXPOSE primes. primeCount
	DO i = 1 TO primeCount
		IF primes.i THEN CALL CHAROUT , i || " "
	END
RETURN
